#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSArray.h>
#import "Program.h"

// Program container
@interface ProgramTable : NSObject {
@private
  NSString* channelName;
  NSString* address;
  NSMutableArray* programs;
  BOOL arranged;
}

// initializers
-(ProgramTable*) initWithChannelName: (NSString*) name;
-(ProgramTable*) initWithChannelNameAndURL: (NSString*) name : (NSString*) url;

// destructor
-(void) dealloc;

// name of the channel
-(NSString*)getChannelName;

// address (URL)
-(void)setAddress : (NSString*) url;
-(NSString*)getAddress;

// getters of each program
-(Program*)getProgram : (int) num;
// getter of programs
-(int)getProgramSize;
-(NSArray*)getPrograms;
-(NSArray*)getProgramWithTimeRange : (int)startMin 
			    minutes: (int)minutes;

// sort programs
-(void) arrange;

// add program, see class Program
-(void) appendProgram : (Program*) program;

// output
-(NSString*)description;

-(NSString*)toHTML : (NSString*) format 
	     start : (int)startTime 
	       end : (int)endTime;
@end
